try
{
  var _oldCountry = mywindow.findChild("_oldCountry");
  var _newCountry = mywindow.findChild("_newCountry");
  var _save       = mywindow.findChild("_save");
  var _cancel     = mywindow.findChild("_cancel");

  var _params = {};

  _save.clicked.connect(sSave);
  _cancel.clicked.connect(mywindow, "close");
}
catch (e)
{
  QMessageBox.critical(mywindow, "bulkFixCountry", "bulkFixCountry.js exception: " + e);
}

function set(params)
{
  try
  {
    if ("cohist" in params)
      _params.cohist = true;
    if ("asohist" in params)
      _params.cohist = true;
    if ("rahead" in params)
      _params.rahead = true;
    if ("tohead" in params)
      _params.tohead = true;

    listParams = { list: true};
    if (mainwindow.key)
      listParams.key = mainwindow.key;
    if ("cohist" in _params)
      listParams.cohist = true;
    if ("asohist" in _params)
      listParams.asohist = true;
    if ("rahead" in _params)
      listParams.rahead = true;
    if ("tohead" in _params)
      listParams.tohead = true;
    var qry = toolbox.executeDbQuery('fixcountry', 'strictcountrycheck', listParams);

    if (qry.lastError().type != QSqlError.NoError)
    {
      QMessageBox.critical(mywindow, qsTr("Error fetching countries"), qry.lastError().text);
      return;
    }

    _oldCountry.populate(qry);
  }
  catch (e)
  {
    QMessageBox.critical(mywindow, "bulkFixCountry", "set(params) exception: " + e);
  }
}

function sSave()
{
  try
  {
    var columns = ["addr_country",
                   "quhead_billtocountry", "quhead_shiptocountry",
                   "cohead_billtocountry", "cohead_shiptocountry",
                   "invchead_billto_country", "invchead_shipto_country",
                   "cmhead_billtocountry", "cmhead_shipto_country",
                   "pohead_vendcountry", "pohead_shiptocountry",
                   "ccard_country", "metric_value"];

    if ("cohist" in _params)
      columns = columns.concat(["cohist_billtocountry", "cohist_shiptocountry"]);
    if ("asohist" in _params)
      columns = columns.concat(["asohist_billtocountry", "asohist_shiptocountry"]);
    if ("rahead" in _params)
      columns = columns.concat(["rahead_billtocountry", "rahead_shipto_country"]);
    if ("tohead" in _params)
      columns = columns.concat(["tohead_srccountry", "tohead_destcountry"]);

    var params = { oldCountry: _oldCountry.currentText,
                   newCountry: _newCountry.currentText };

    if (mainwindow.key)
      params.key = mainwindow.key;

    for (i = 0; i < columns.length; i++)
    {
      params.table = columns[i].split("_")[0];
      params.column = columns[i];

      if (columns[i] == "metric_value")
        params.metric = true;
      else if (params.metric)
        delete params.metric;

      var qry = toolbox.executeQuery("ALTER TABLE <? literal('table') ?> DISABLE TRIGGER ALL;",
                                     params);

      if (qry.lastError().type != QSqlError.NoError)
      {
        QMessageBox.critical(mywindow, qsTr("Error replacing countries"), qry.lastError().text);
        return;
      }

      if (columns[i] == "ccard_country")
      {
        if (mainwindow.key)
          qry = toolbox.executeQuery("UPDATE ccard "
                                   + "   SET ccard_country = "
                                   + "       encrypt(setbytea(<? value('newCountry') ?>), "
                                   + "               setbytea(<? value('key') ?>), "
                                   + "               'bf') "
                                   + " WHERE formatbytea(decrypt(setbytea(ccard_country), "
                                   + "                           setbytea(<? value('key') ?>), "
                                   + "                           'bf')) = "
                                   + "       <? value('oldCountry') ?>;",
                                     params);
        else
          QMessageBox.critical(mywindow, qsTr("Cannot update ccard table"),
                               qsTr("Cannot update the ccard table without having the encryption key"));
      }
      else
      {
        qry = toolbox.executeQuery("UPDATE <? literal('table') ?> "
                                 + "   SET <? literal('column') ?> = <? value('newCountry') ?> "
                                 + " WHERE <? literal('column') ?> = <? value('oldCountry') ?> "
                                 + "<? if exists('metric') ?> "
                                 + "   AND metric_name IN ('DefaultAddressCountry', "
                                 + "                       'remitto_country') "
                                 + "<? endif ?>;",
                                   params);
      }

      if (qry.lastError().type != QSqlError.NoError)
      {
        QMessageBox.critical(mywindow, qsTr("Error replacing countries"), qry.lastError().text);
        return;
      }

      qry = toolbox.executeQuery("ALTER TABLE <? literal('table') ?> ENABLE TRIGGER ALL;", params);

      if (qry.lastError().type != QSqlError.NoError)
      {
        QMessageBox.critical(mywindow, qsTr("Error replacing countries"), qry.lastError().text);
        return;
      }
    }

    mywindow.close();
  }
  catch (e)
  {
    QMessageBox.critical(mywindow, "bulkFixCountry", "sSave() exception: " + e);
  }
}
